/*
 * Br2Hdr.hpp  --  Part of the CinePaint plug-in "Bracketing_to_HDR"
 *
 * Copyright (c) 2005-2006  Hartmut Sbosny  <hartmut.sbosny@gmx.de>
 *
 * LICENSE:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/**
  @file  Br2Hdr.hpp
  
  Defines the singular `Manager' instance `Br2Hdr::Instance()'.
  
  Currently we include "../gui/Br2HdrManagerGui.hpp" and this is the 
   only one reference in "core" to any "gui" file. 
*/
#ifndef Br2Hdr_hpp
#define Br2Hdr_hpp

//#include "Br2HdrManager.hpp"
#include "../gui/Br2HdrManagerGui.hpp"


namespace br {

/**======================================================================
*
*   @class Br2Hdr  -  Class allowing only a singular `Manager' instance.
*                    
*   Derived from Br2HdrManagerGui to use the GUI-completed Manager class.
*
*========================================================================*/
class Br2Hdr : public Br2HdrManagerGui
{
public: 
    static Br2Hdr & Instance()
      {
        static Br2Hdr instance_;
        return instance_;
      }
    
private:
    //  Private Ctor: instantiations only from inside the class
    Br2Hdr()  {}
};


}  // namespace

#endif  // Br2Hdr_hpp

// END OF FILE
